// This file was generated by gir (https://github.com/gtk-rs/gir)
// from
// from gir-files (https://github.com/gtk-rs/gir-files.git)
// DO NOT EDIT

use crate::ffi;
use glib::{prelude::*, translate::*};

glib::wrapper! {
    #[doc(alias = "SecretPrompt")]
    pub struct Prompt(Object<ffi::SecretPrompt, ffi::SecretPromptClass>) @extends gio::DBusProxy, @implements gio::DBusInterface, gio::Initable;

    match fn {
        type_ => || ffi::secret_prompt_get_type(),
    }
}

impl Prompt {
    pub const NONE: Option<&'static Prompt> = None;
}

mod sealed {
    pub trait Sealed {}
    impl<T: super::IsA<super::Prompt>> Sealed for T {}
}

pub trait PromptExt: IsA<Prompt> + sealed::Sealed + 'static {
    #[doc(alias = "secret_prompt_perform_sync")]
    fn perform_sync(
        &self,
        window_id: Option<&str>,
        cancellable: Option<&impl IsA<gio::Cancellable>>,
        return_type: &glib::VariantTy,
    ) -> Result<glib::Variant, glib::Error> {
        unsafe {
            let mut error = std::ptr::null_mut();
            let ret = ffi::secret_prompt_perform_sync(
                self.as_ref().to_glib_none().0,
                window_id.to_glib_none().0,
                cancellable.map(|p| p.as_ref()).to_glib_none().0,
                return_type.to_glib_none().0,
                &mut error,
            );
            if error.is_null() {
                Ok(from_glib_full(ret))
            } else {
                Err(from_glib_full(error))
            }
        }
    }

    #[doc(alias = "secret_prompt_run")]
    fn run(
        &self,
        window_id: Option<&str>,
        cancellable: Option<&impl IsA<gio::Cancellable>>,
        return_type: &glib::VariantTy,
    ) -> Result<glib::Variant, glib::Error> {
        unsafe {
            let mut error = std::ptr::null_mut();
            let ret = ffi::secret_prompt_run(
                self.as_ref().to_glib_none().0,
                window_id.to_glib_none().0,
                cancellable.map(|p| p.as_ref()).to_glib_none().0,
                return_type.to_glib_none().0,
                &mut error,
            );
            if error.is_null() {
                Ok(from_glib_full(ret))
            } else {
                Err(from_glib_full(error))
            }
        }
    }
}

impl<O: IsA<Prompt>> PromptExt for O {}
